﻿// #define DrawBox

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Drawing;

namespace howto_draw_equations
{
    // Draw some text.
    class StringEquation : Equation
    {
        // The text to draw.
        private string Text;

        // Initialize the text.
        public StringEquation(string text)
        {
            Text = text;
        }

        // Set font sizes for sub-equations.
        public override void SetFontSizes(float font_size)
        {
            FontSize = font_size;
        }

        // Return the equation's size.
        public override SizeF GetSize(Graphics gr, Font font)
        {
            using (Font new_font = new Font(font.FontFamily, FontSize, font.Style))
            {
                return gr.MeasureString(Text, new_font);
            }
        }

        // Draw the equation.
        public override void Draw(Graphics gr, Font font, Pen pen, Brush brush, float x, float y)
        {
#if DrawBox
            SizeF our_size = GetSize(gr, font);
            using (Pen dashed_pen = new Pen(Color.Red, 0))
            {
                dashed_pen.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
                gr.DrawRectangle(dashed_pen, x, y, our_size.Width, our_size.Height);
            }
#endif
            using (Font new_font = new Font(font.FontFamily, FontSize, font.Style))
            {
                gr.DrawString(Text, new_font, brush, x, y);
            }
        }
    }
}
